#include <amxmodx>
#include <engine>
#include <fakemeta>

// GetPdataByte(iEntity, iOffset, iLinuxOffset)
#define GetPdataByte(%0,%1,%2)	((get_pdata_int(%0, %1 / 4, %2) >> (8 * (%1 % 4))) & 0xFF)

//   
#define OFFSET_TURNEDNVG		517	//    

//     
#define CBasePlayer				5

//     
#define OBS_IN_EYE				4

//      
#define PlayerTurnedNvg(%0)		GetPdataByte(%0, OFFSET_TURNEDNVG, CBasePlayer)
//   
#define PlayerSpectateMode(%0)	entity_get_int(%0, EV_INT_iuser1)
//     
#define PlayerSpectate(%0)		entity_get_int(%0, EV_INT_iuser2)

// 
#define NVG_UPDATE				0.1	//      ()
#define NVG_RADIUS				80	//  
#define NVG_COLOR_R				255 //    (RED)
#define NVG_COLOR_G				0	// GREEN
#define NVG_COLOR_B				0	// BLUE
#define NVG_LIFE				2	//  
#define NVG_DECAYRATE			0	// 

// 
public plugin_init()
{
	// 
	register_plugin("Custom NVG", "Alpha", "WPMG PRoSToTeM@");
	
	//    
	set_msg_block(get_user_msgid("NVGToggle"), BLOCK_SET);
	
	//      
	set_task(NVG_UPDATE, "TaskNVG", _, _, _, "b");
}

//   
public TaskNVG()
{
	// ,  , ,  
	new iPlayers[32], iPlayersCount, iEntity, iSpectating;
	
	//  
	get_players(iPlayers, iPlayersCount);
	
	//    
	for (new i = 0; i < iPlayersCount; i++)
	{
		//   
		iEntity = iPlayers[i];
		
		//   
		if (is_user_alive(iEntity))
		{
			//         
			if (!PlayerTurnedNvg(iEntity))
				continue;
		}
		//   
		else
		{
			//           
			if (PlayerSpectateMode(iEntity) != OBS_IN_EYE)
				continue;
			
			//   
			iSpectating = PlayerSpectate(iEntity);
			
			//          
			if (!is_user_alive(iSpectating))
				continue;
			//           
			if (!PlayerTurnedNvg(iSpectating))
				continue;
		}
		
		//   
		new iOrigin[3];
		
		get_user_origin(iEntity, iOrigin);
		
		//  
		message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, iEntity);
		write_byte(TE_DLIGHT);
		write_coord(iOrigin[0]); // 
		write_coord(iOrigin[1]);
		write_coord(iOrigin[2]);
		write_byte(NVG_RADIUS); // 
		write_byte(NVG_COLOR_R); // 
		write_byte(NVG_COLOR_G);
		write_byte(NVG_COLOR_B);
		write_byte(NVG_LIFE); // 
		write_byte(NVG_DECAYRATE); // Decay rate
		message_end();
	}
}